오등큰수
1 초 | 512 MB | 10157 | 4539 | 3497 | 44.328% |
문제
크기가 N인 수열 A = A1, A2, ..., AN이 있다. 수열의 각 원소 Ai에 대해서 오등큰수 NGF(i)를 구하려고 한다.
Ai가 수열 A에서 등장한 횟수를 F(Ai)라고 했을 때, Ai의 오등큰수는 오른쪽에 있으면서 수열 A에서 등장한 횟수가 F(Ai)보다 큰 수 중에서 가장 왼쪽에 있는 수를 의미한다. 그러한 수가 없는 경우에 오등큰수는 -1이다.
예를 들어, A = [1, 1, 2, 3, 4, 2, 1]인 경우 F(1) = 3, F(2) = 2, F(3) = 1, F(4) = 1이다. A1의 오른쪽에 있으면서 등장한 횟수가 3보다 큰 수는 없기 때문에, NGF(1) = -1이다. A3의 경우에는 A7이 오른쪽에 있으면서 F(A3=2) < F(A7=1) 이기 때문에, NGF(3) = 1이다. NGF(4) = 2, NGF(5) = 2, NGF(6) = 1 이다.
입력
첫째 줄에 수열 A의 크기 N (1 ≤ N ≤ 1,000,000)이 주어진다. 둘째에 수열 A의 원소 A1, A2, ..., AN (1 ≤ Ai ≤ 1,000,000)이 주어진다.
출력
총 N개의 수 NGF(1), NGF(2), ..., NGF(N)을 공백으로 구분해 출력한다.
예제 입력 1 복사
7
1 1 2 3 4 2 1
예제 출력 1 복사
-1 -1 1 2 2 1 -1
풀이
https://keeeeeepgoing.tistory.com/131
오큰수 문제처럼
스택2개를 이용했고, 빈도수도 필요하니까 map을 추가해서 사용하였다.
public class Main {
static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
static BufferedWriter bw = new BufferedWriter(new OutputStreamWriter(System.out));
/*
*/
static Map<Integer, Integer> map = new HashMap<>();
static Stack<Integer> stack1 = new Stack<>();
static Stack<Integer> stack2 = new Stack<>();
static int n;
static int[] input;
public static void main(String[] args) throws IOException {
input();
solve();
bw.flush();
bw.close();
}
static void input() throws IOException {
n = Integer.parseInt(br.readLine());
input = Arrays.stream(br.readLine().split(" ")).mapToInt(Integer::parseInt).toArray();
for (int number : input) {
map.put(number, map.getOrDefault(number, 0) + 1);
stack1.add(number);
}
}
static void solve() throws IOException {
List<Integer> keySet = new ArrayList<>(map.keySet());
keySet.sort(new Comparator<Integer>() {
@Override
public int compare(Integer o1, Integer o2) {
return map.get(o1)-map.get(o2);
}
});
List<Integer> result = new ArrayList<>();
//맨 오른쪽 숫자는 -1이니까
result.add(-1);
stack2.add(stack1.pop());
while (!stack1.isEmpty()) {
int currentNumber = stack1.pop();
int currentStack2Size = stack2.size();
for (int i = 0; i < currentStack2Size; i++) {
if (map.get(currentNumber) < map.get(stack2.peek())) {
result.add(stack2.peek());
stack2.add(currentNumber);
break;
} else {
stack2.pop();
}
}
if (stack2.isEmpty()) {
result.add(-1);
stack2.add(currentNumber);
}
}
for (int i = n - 1; i >= 0; i--) {
bw.write(result.get(i)+" ");
}
}
}
다른사람풀이
인덱스를 응용한 풀이
https://binghedev.tistory.com/49
나랑 비슷한 풀이
https://imnotabear.tistory.com/620
'자바 > 알고리즘 문제 풀이' 카테고리의 다른 글
백준/24444 알고리즘 수업 - 너비 우선 탐색 1 / bfs (0) | 2022.12.26 |
---|---|
★백준/24479 알고리즘 수업 - 깊이 우선 탐색 1 / dfs (1) | 2022.12.26 |
★백준/17298 오큰수 / 스택 (0) | 2022.12.26 |
★백준/9935 문자열 폭발/ 스택,리스트 (0) | 2022.12.26 |
★백준/1655 가운데를 말해요 / 우선순위큐 (0) | 2022.12.24 |
댓글